/*--------------------------------------------------------------------
This source distribution is placed in the public domain by its author,
Jason Papadopoulos. You may use it for any purpose, free of charge,
without having to notify anyone. I disclaim any responsibility for any
errors.

Optionally, please be nice and tell me if you find this source to be
useful. Again optionally, if you add to the functionality present here
please consider making those additions public too, so that others may 
benefit from your work.	
       				   --jasonp@boo.net 1/5/07
--------------------------------------------------------------------*/

#ifndef _SQRT_H_
#define _SQRT_H_

#include "gnfs.h"
#include <ap.h>

typedef struct {
	int32 a;
	uint32 b;
} abpair_t;

void alg_square_root(msieve_obj *obj, mp_poly_t *monic_alg_poly, 
			mp_t *n, mp_t *c, mp_t *m1, signed_mp_t *m0,
			abpair_t *rlist, uint32 num_relations,
			mp_t *sqrt_a);

#endif /* _SQRT_H_ */
